package net.mosgrom.modvid.gamelib;

import java.awt.Point;

class Engine {

	private Ship ship;
	private Point origin;
	private Point destination;
	private double speed;
	private double startTime;
	private double eta;
	
	Engine(Ship s) {
		ship = s;
		this.origin = s.location();
		this.destination = origin; 
	}
	
	void setCourse(Point destination, double speed) {
		this.destination = destination;
		this.speed = speed;
		this.origin = ship.location();
		startTime = System.currentTimeMillis();
		eta = startTime + (origin.distance(destination) / speed);
	}
	
	Point currentLocation() {
		double t = System.currentTimeMillis();
		if (t <= eta) {
			double dt = t - startTime;
			double a = Math.atan2(destination.getY() - origin.getY(), destination.getX() - origin.getX());
			double dx = speed * dt * Math.cos(a);
			double dy = speed * dt *  Math.sin(a);
			return new Point((int)Math.round(origin.getX() + dx), (int)Math.round(origin.getY() + dy));
		} else {
			return destination;
		}		
	}
	
	boolean destinationReached() {
		return origin == destination || currentLocation().equals(destination);
	}
	
}
